VERSION 5.00
Begin VB.UserControl PhoneBox 
   ClientHeight    =   570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4185
   LockControls    =   -1  'True
   PropertyPages   =   "PhBox.ctx":0000
   ScaleHeight     =   570
   ScaleWidth      =   4185
   ToolboxBitmap   =   "PhBox.ctx":002E
   Begin VB.CheckBox chkPhoneNumber 
      Caption         =   "Check1"
      Height          =   195
      Left            =   150
      TabIndex        =   1
      Top             =   150
      Width           =   195
   End
   Begin VB.TextBox txtPhoneNumber 
      Height          =   345
      Left            =   2250
      TabIndex        =   0
      Top             =   90
      Width           =   1665
   End
   Begin VB.Label lblBackGround 
      Height          =   285
      Left            =   1200
      TabIndex        =   2
      Top             =   90
      Width           =   915
   End
End
Attribute VB_Name = "PhoneBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event Change _
                ( _
                IsAmbiguous As Boolean _
                )

Public Event Click()

Public Event DblClick()

Public Event KeyDown _
                ( _
                KeyCode As Integer, _
                Shift As Integer _
                )

Public Event KeyPress _
                ( _
                KeyAscii As Integer _
                )

Public Event KeyUp _
                ( _
                KeyCode As Integer, _
                Shift As Integer _
                )

Public Event MouseDown _
                ( _
                Button As Integer, _
                Shift As Integer, _
                X As Single, _
                Y As Single _
                )

Public Event MouseMove _
                ( _
                Button As Integer, _
                Shift As Integer, _
                X As Single, _
                Y As Single _
                )

Public Event MouseUp _
                ( _
                Button As Integer, _
                Shift As Integer, _
                X As Single, _
                Y As Single _
                )

Public Event AutoChekDialog _
                ( _
                CallType As VbCallType, _
                Value As Boolean _
                )

Public Event CheckBoxClick()

Public Event DescriptionChange()

Public Enum TextBoxBorderStyleConstants
    vbNone = 0
    vbFixedSingle = 1
End Enum

Private Const MODULE As String = "PhoneBox"

Private WithEvents m_objPhoneNumber     As PhoneNumber
Attribute m_objPhoneNumber.VB_VarHelpID = -1
Private WithEvents m_objCheckBox        As PhoneCheck
Attribute m_objCheckBox.VB_VarHelpID = -1
Private WithEvents m_objFont            As stdole.StdFont
Attribute m_objFont.VB_VarHelpID = -1
Private m_objCheckPhone                 As frmCheckPhone
Private m_blnIsDirty                    As Boolean
Private m_blnIsAmbiguous                As Boolean
Private m_blnDoNotParse                 As Boolean
Private m_strCountryList                As String
Private m_strDefaultCountryCode         As String
Private m_enmAppearance                 As ApperaranceConstants
Private m_enmBorderStyle                As BorderStyleConstants
Private m_blnMouseEnter                 As Boolean

Private Declare Function GetProfileInt Lib "kernel32" Alias "GetProfileIntA" _
                            ( _
                            ByVal p_strAppName As String, _
                            ByVal p_strKeyName As String, _
                            ByVal p_lngDefault As Long _
                            ) As Long

Private Property Let DoNotParse _
                        ( _
                        ByVal RHS As Boolean _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "DoNotParse[Let]"
    
    On Error GoTo ErrorHandler
    
    m_blnDoNotParse = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Private Property Get DoNotParse() As Boolean

    DoNotParse = m_blnDoNotParse

End Property

Private Property Let IsDirty _
                        ( _
                        ByVal RHS As Boolean _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "IsDirty[Let]"
    
    On Error GoTo ErrorHandler
    
    m_blnIsDirty = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Private Property Get IsDirty() As Boolean

    IsDirty = m_blnIsDirty

End Property

Private Property Let DefaultCountryCode _
                        ( _
                        ByVal RHS As String _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "DefaultCountryCode[Let]"

    On Error GoTo ErrorHandler
    
    m_strDefaultCountryCode = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Private Property Get DefaultCountryCode() As String

    DefaultCountryCode = m_strDefaultCountryCode

End Property

Private Property Let CountryList _
                        ( _
                        ByVal RHS As String _
                        )

    Const PROC_SIG As String = MODULE & "." & "CountryList[Let]"

    On Error GoTo ErrorHandler
    
    m_strCountryList = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Private Property Get CountryList() As String

    CountryList = m_strCountryList

End Property

Private Property Let IsAmbiguous _
                        ( _
                        ByVal RHS As Boolean _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "IsAmbiguous[Let]"
    
    On Error GoTo ErrorHandler
    
    m_blnIsAmbiguous = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get IsAmbiguous() As Boolean

    IsAmbiguous = m_blnIsAmbiguous

End Property

Private Sub m_objCheckBox_Click()
    
    Const PROC_SIG As String = MODULE & "." & "m_objCheckBox_Click[Sub]"

    On Error GoTo ErrorHandler
    
    If m_objCheckBox.Value = vbChecked Then
        
        txtPhoneNumber.Enabled = True
    
    ElseIf chkPhoneNumber.Value = vbUnchecked Then
        
        txtPhoneNumber.Enabled = False
    
    End If
    
    RaiseEvent CheckBoxClick

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub m_objCheckBox_CheckChanged _
                        ( _
                        p_strPropertyName As String _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "m_objCheckBox_CheckChanged[Sub]"
    
    On Error GoTo ErrorHandler
    
    PropertyChanged "CheckBox" & p_strPropertyName
    
    If UCase$(p_strPropertyName) = "VISIBLE" Then
        
        UserControl_Resize
    
    End If
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub m_objFont_FontChanged _
                        ( _
                        ByVal PropertyName As String _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "m_objFont_FontChanged[Sub]"
    
    On Error GoTo ErrorHandler
    
    Set UserControl.Font = m_objFont
    Set txtPhoneNumber.Font = m_objFont
    Refresh

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub m_objPhoneNumber_PhoneChanged _
                        ( _
                        p_strPropertyName As String _
                        )

    Const PROC_SIG As String = MODULE & "." & "m_objPhoneNumber_PhoneChanged[Sub]"

    On Error GoTo ErrorHandler
    
    DoNotParse = True
    
    txtPhoneNumber.Text = PhoneNumber.Serialize(False)
    
    DoNotParse = False
    
    PropertyChanged "Phone" & p_strPropertyName
    
    If UCase$(p_strPropertyName) = "DESCRIPTION" Then
        RaiseEvent DescriptionChange
    End If
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub txtPhoneNumber_Change()
    
    Const PROC_SIG As String = MODULE & "." & "txtPhoneNumber_Change[Sub]"
    
    On Error GoTo ErrorHandler
    
    Debug.Print Now & " " & "txtPhoneNumber_Change"
    If Not DoNotParse Then
    
        ParsePhone
    
    End If
    
    If Len(txtPhoneNumber.Text) > 0 Then
        
        IsDirty = True
    
    End If
    
    RaiseEvent Change(IsAmbiguous)

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub txtPhoneNumber_DblClick()
    
    Const PROC_SIG As String = MODULE & "." & "txtPhoneNumber_DblClick[Sub]"
    
    On Error GoTo ErrorHandler
    
    Debug.Print Now & " " & "txtPhoneNumber_DblClick"
    RaiseEvent DblClick
    
    ShowChekDialog
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Public Property Get PhoneNumber() As PhoneNumber
Attribute PhoneNumber.VB_MemberFlags = "400"

    Set PhoneNumber = m_objPhoneNumber

End Property

Public Sub ShowChekDialog()
    
    Const PROC_SIG As String = MODULE & "." & "ShowCheckDialog[Sub]"
    
    Dim v_strCountryCode As String
    
    On Error GoTo ErrorHandler
    
    ' To avoid re-entrance
    If Not m_objCheckPhone Is Nothing Then GoTo ExitHere
    
    Set m_objCheckPhone = New frmCheckPhone
    
    With m_objCheckPhone
        
        v_strCountryCode = PhoneNumber.CountryCode
        
        With .PhoneNumber
            .CountryCode = IIf(Len(v_strCountryCode) > 0, v_strCountryCode, DefaultCountryCode)
            .Description = PhoneNumber.Description
            .LocalNumber = PhoneNumber.LocalNumber
            .CityCode = PhoneNumber.CityCode
        End With
        
        .ShowAgain = AutoChekDialog
        .CountryList = CountryList
        .Locked = Me.Locked
        
        .Show vbModal
         
        If .ApplyChanges Then
        
            With .PhoneNumber
                PhoneNumber.CountryCode = .CountryCode
                PhoneNumber.Description = .Description
                PhoneNumber.LocalNumber = .LocalNumber
                PhoneNumber.CityCode = .CityCode
            End With
                
            AutoChekDialog = .ShowAgain
            
            DoNotParse = True
            
            ' We don't want this number to be parsed
            ' because we already know it's well
            ' formatted. Anyway, we still want the
            ' change event to fire so the host application
            ' knows that the phone number has changed
            
            txtPhoneNumber.Text = PhoneNumber.Serialize(False)
            
            ' Before raising the Change event we must set the
            ' Ambiguous flag. The procedure that decides whether
            ' a Phone number is Ambiguous or not is ParsePhone.
            ' Since we don't want the phone number to be parsed
            ' again. We must set it manually.
            
            IsAmbiguous = GetIsAmbiguous(Me.PhoneNumber)
            
            ' NOTE: now the logic for deciding whether a phone
            ' number is valid or not will be duplicated...
            ' Keep in mind to change both procedures if any changes
            ' are made
            
            RaiseEvent Change(IsAmbiguous)
            
            DoNotParse = False
                        
        End If
    
        IsDirty = False
    
    End With
    
    Set m_objCheckPhone = Nothing

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Function IsInCountryList _
                        ( _
                        ByVal p_strCountryCode As String _
                        ) As Boolean

    Const PROC_SIG As String = MODULE & "." & "IsInCountryList[Function]"

    On Error GoTo ErrorHandler
    
    p_strCountryCode = StripPlus(p_strCountryCode)
    
    IsInCountryList = (InStr(1, CountryList, "=" & p_strCountryCode & "@", vbTextCompare) > 0)

ExitHere:
    Exit Function
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Function

Private Function GetIsAmbiguous _
                    ( _
                    p_objPhoneNumber As PhoneNumber _
                    ) As Boolean
                    
    Const PROC_SIG          As String = MODULE & "." & "GetIsAmbiguous[Function]"
                
    Dim v_blnIsAmbiguous    As Boolean
                
    On Error GoTo ErrorHandler
    
    v_blnIsAmbiguous = False
    
    With p_objPhoneNumber
         
        If Len(.LocalNumber) = 0 Then
            v_blnIsAmbiguous = True
        Else
            If Len(.CityCode) = 0 Then
                v_blnIsAmbiguous = True
            Else
                If Left$(.CityCode, 1) <> "(" Or _
                    Right$(.CityCode, 1) <> ")" Then
                                        
                    v_blnIsAmbiguous = True
                Else
                    If Len(.CountryCode) = 0 Then
                        v_blnIsAmbiguous = True
                    Else
                        If Left$(.CountryCode, 1) <> "+" Then
                            v_blnIsAmbiguous = True
                        End If
                    End If
                End If
            End If
        End If
    
    End With

ExitHere:
    Exit Function
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Function

Private Sub ParsePhone()
    
    Const PROC_SIG          As String = MODULE & "." & "ParsePhone[Sub]"
    Const BLANK_SPACE       As String = " "
    
    Dim v_strPhoneNumber    As String
    
    Dim v_strCountryCode    As String
    Dim v_strCityCode       As String
    Dim v_strLocalNumber    As String
    
    Dim v_lngInstr          As Long
    Dim v_lngInstr2         As Long
    Dim v_lngInstr3         As Long
    
    On Error GoTo ErrorHandler
    
    IsAmbiguous = False
    
    PhoneNumber.RaiseEvents = False
    
EmptyPhone:
    With PhoneNumber
        .CountryCode = vbNullString
        .CityCode = vbNullString
        .LocalNumber = vbNullString
    End With
    
    v_strPhoneNumber = Trim$(txtPhoneNumber.Text)
    
    If Len(v_strPhoneNumber) = 0 Then GoTo ExitHere
    
    v_lngInstr = InStr(1, v_strPhoneNumber, BLANK_SPACE)
    
    If v_lngInstr > 0 Then
    
        v_lngInstr2 = InStr(v_lngInstr + 1, v_strPhoneNumber, BLANK_SPACE)
        
        If v_lngInstr2 > 0 Then
        
            If v_lngInstr2 = v_lngInstr + 1 Then
                Do Until Mid$(v_strPhoneNumber, v_lngInstr2, 1) <> BLANK_SPACE
                    
                    v_lngInstr2 = v_lngInstr2 + 1
                    
                Loop
                
                v_lngInstr3 = InStr(v_lngInstr2 + 1, v_strPhoneNumber, BLANK_SPACE)
                
                If v_lngInstr3 > 0 Then
                                        
                    v_strCountryCode = Trim$(Left$(v_strPhoneNumber, v_lngInstr - 1))
                    v_strCityCode = Trim$(Mid$(v_strPhoneNumber, v_lngInstr + 1, (v_lngInstr2 - v_lngInstr) + 1))
                    v_strLocalNumber = Trim$(Mid$(v_strPhoneNumber, v_lngInstr3 + 1))
                    
                    GoTo CountryCityAndLocalNumber
                                    
                Else
                    
                    GoTo CityAndLocalNumber
                                    
                End If
            Else
                
                v_strCountryCode = Trim$(Left$(v_strPhoneNumber, v_lngInstr - 1))
                v_strCityCode = Trim$(Mid$(v_strPhoneNumber, v_lngInstr + 1, (v_lngInstr2 - v_lngInstr)))
                v_strLocalNumber = Trim$(Mid$(v_strPhoneNumber, v_lngInstr2 + 1))
            
CountryCityAndLocalNumber:
                With PhoneNumber
                    
                    If Not IsInCountryList(v_strCountryCode) Then
                        
                        GoTo CityAndLocalNumber
                        
                    End If
                    
                    If Not Left$(v_strCountryCode, 1) = "+" Then
                        IsAmbiguous = True
                    End If
                    
                    .CountryCode = v_strCountryCode
                    
                    If Not ((Left$(v_strCityCode, 1) = "(") And (Right$(v_strCityCode, 1) = ")")) Then
                        IsAmbiguous = True
                    End If
                    
                    .CityCode = v_strCityCode
                    .LocalNumber = v_strLocalNumber
                End With
            
            End If
        Else
CityAndLocalNumber:
            
            v_strCityCode = Trim$(Left$(v_strPhoneNumber, v_lngInstr - 1))
            v_strLocalNumber = Trim$(Mid$(v_strPhoneNumber, v_lngInstr + 1))
                    
            With PhoneNumber
                .CityCode = v_strCityCode
                .LocalNumber = v_strLocalNumber
            End With
        
            IsAmbiguous = True
            
        End If
            
    Else
LocalNumber:
        
        With PhoneNumber
            .LocalNumber = v_strPhoneNumber
        End With
        
        IsAmbiguous = True
        
    End If
    
ExitHere:
    GoSub CleanUp
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    GoSub CleanUp
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
CleanUp:
    PhoneNumber.RaiseEvents = True
    Return
End Sub

Private Function GetDefaultCountryCode() As String
    
    Const PROC_SIG As String = MODULE & "." & "GetDefaultCountryCode[Function]"
    
    Dim v_lngDefaultCountryCode As Long
    
    On Error GoTo ErrorHandler
    
    ' GetProfileInt will be redirected to the Registry in Windows NT/2000
    v_lngDefaultCountryCode = GetProfileInt("INTL", "iCountry", 0)
    
    GetDefaultCountryCode = IIf(v_lngDefaultCountryCode > 0, CStr(v_lngDefaultCountryCode), vbNullString)

ExitHere:
    Exit Function
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Function

Private Property Let AutoChekDialog _
                        ( _
                        ByVal RHS As Boolean _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "AutoCheck"
    
    On Error GoTo ErrorHandler
    
    RaiseEvent AutoChekDialog(VbLet, RHS)

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Private Property Get AutoChekDialog() As Boolean
    
    Const PROC_SIG As String = MODULE & "." & "AutoCheckDialog[Get]"
    On Error GoTo ErrorHandler
    
    Dim v_blnAutoChekDialog As Boolean
    
    RaiseEvent AutoChekDialog(VbGet, v_blnAutoChekDialog)
    
    AutoChekDialog = v_blnAutoChekDialog
        
ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Private Sub txtPhoneNumber_GotFocus()

    Const PROC_SIG As String = MODULE & "." & "txtPhoneNumber[Sub]"

    On Error GoTo ErrorHandler
    
    Debug.Print Now & " " & "txtPhoneNumber_GotFocus"
    If Not m_blnMouseEnter Then
        With txtPhoneNumber
            .SelStart = 0
            .SelLength = Len(.Text)
        End With
    End If
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub txtPhoneNumber_LostFocus()
    
    Const PROC_SIG As String = MODULE & "." & "txtPhoneNumber_LostFocus[Sub]"
    
    On Error GoTo ErrorHandler
    
    Debug.Print Now & " " & "txtPhoneNumber_LostFocus"
    If Not IsDirty Then GoTo ExitHere
    
    If Not IsAmbiguous Then GoTo ExitHere
    
    If Not AutoChekDialog Then GoTo ExitHere
    
    ShowChekDialog
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub UserControl_AmbientChanged _
                        ( _
                        PropertyName As String _
                        )

    Const PROC_SIG As String = MODULE & "." & "UserControl_AmbientChanged[Sub]"
    
    On Error GoTo ErrorHandler
    
    ' When execution is halted by pressing the stop button or
    ' issuing and End statement from the immediate pane ...
    If PropertyName = "UIDead" Then GoTo ExitHere
    
    ' When the Name property of the control is changed in the
    ' properties window in design time ...
    If PropertyName = "DisplayName" Then GoTo ExitHere
    
    ' When executing in IE the AmbientChanged event is
    ' raised when the control loads into the Browser.
    ' When this heppens, PropertyName = "Palette"... and
    ' We don't want to do anythig with it do we?
    If PropertyName = "Palette" Then GoTo ExitHere
    
    If UCase$(PropertyName) = "FONT" Then
        
        Set UserControl.Font = Ambient.Font
        Set txtPhoneNumber.Font = Ambient.Font
        
        Refresh
    
    Else
        
        CallByName Me, PropertyName, VbLet, CallByName(Ambient, PropertyName, VbGet)
    
    End If

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert False ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume Next
End Sub

Public Property Let PhoneCityCode _
                        ( _
                        ByVal RHS As String _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "PhoneCityCode[Let]"
    
    On Error GoTo ErrorHandler
    
    PhoneNumber.CityCode = RHS
    
    PropertyChanged "PhoneCityCode"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get PhoneCityCode() As String
Attribute PhoneCityCode.VB_ProcData.VB_Invoke_Property = "pagPhone"
    
    PhoneCityCode = PhoneNumber.CityCode

End Property

Public Property Let PhoneCountryCode _
                        ( _
                        ByVal RHS As String _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "PhoneCountryCode[Let]"
    
    On Error GoTo ErrorHandler
    
    PhoneNumber.CountryCode = RHS
    PropertyChanged "PhoneCountryCode"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get PhoneCountryCode() As String
Attribute PhoneCountryCode.VB_ProcData.VB_Invoke_Property = "pagPhone"
    
    PhoneCountryCode = PhoneNumber.CountryCode

End Property

Public Property Let PhoneLocalNumber _
                        ( _
                        ByVal RHS As String _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "PhoneLocalNumber[Let]"
    
    On Error GoTo ErrorHandler
    
    PhoneNumber.LocalNumber = RHS
    PropertyChanged "PhoneLocalNumber"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get PhoneLocalNumber() As String
Attribute PhoneLocalNumber.VB_ProcData.VB_Invoke_Property = "pagPhone"
    
    PhoneLocalNumber = PhoneNumber.LocalNumber

End Property

Public Property Let PhoneDescription _
                        ( _
                        ByVal RHS As String _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "PhoneDescription[Let]"
    
    On Error GoTo ErrorHandler
    
    PhoneNumber.Description = RHS
    PropertyChanged "PhoneDescription"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get PhoneDescription() As String
Attribute PhoneDescription.VB_ProcData.VB_Invoke_Property = "pagPhone"
    
    PhoneDescription = PhoneNumber.Description

End Property

Private Sub UserControl_Initialize()

    Const PROC_SIG As String = MODULE & "." & "UserControl_Initialize[Sub]"

    On Error GoTo ErrorHandler
    
    Debug.Print "Initialize"
    
    Set m_objPhoneNumber = New PhoneNumber
    
    Set m_objFont = New StdFont
    Set UserControl.Font = m_objFont
    Set txtPhoneNumber.Font = m_objFont
    
    Set m_objCheckBox = New PhoneCheck
    Set m_objCheckBox.Object = chkPhoneNumber
     
    DefaultCountryCode = GetDefaultCountryCode
    CountryList = LoadResString(ResStrCountryList)
    
    ParsePhone
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert False ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume Next
End Sub

Public Property Get CheckBox() As PhoneCheck

    Set CheckBox = m_objCheckBox

End Property

Public Property Let CheckBoxVisible _
                        ( _
                        ByVal RHS As Boolean _
                        )

    Const PROC_SIG As String = MODULE & "." & "CheckBoxVisible[Let]"

    On Error GoTo ErrorHandler
    
    CheckBox.Visible = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get CheckBoxVisible() As Boolean

    CheckBoxVisible = CheckBox.Visible

End Property

Public Property Let CheckBoxValue _
                        ( _
                        ByVal RHS As CheckBoxConstants _
                        )

    Const PROC_SIG As String = MODULE & "." & "CheckBoxValue[Let]"

    On Error GoTo ErrorHandler
    
    CheckBox.Value = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get CheckBoxValue() As CheckBoxConstants
    
    CheckBoxValue = CheckBox.Value

End Property

Public Property Let CheckBoxAppearance _
                        ( _
                        ByVal RHS As ApperaranceConstants _
                        )

    Const PROC_SIG As String = MODULE & "." & "CheckBoxAppearence[Let]"

    On Error GoTo ErrorHandler
    
    CheckBox.Appearance = RHS

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get CheckBoxAppearance() As ApperaranceConstants
    
    CheckBoxAppearance = CheckBox.Appearance

End Property

Private Sub UserControl_Resize()
        
    On Error Resume Next
    Debug.Print Now & " " & "Resize"
    ResizeControl

End Sub

Private Sub ResizeControl()
    
    Const PROC_SIG As String = MODULE & "." & "ResizeControl[Sub]"
    Const MINHEIGHT As Long = 285
        
    On Error GoTo ErrorHandler
        
    Debug.Print "Resize"
        
    If UserControl.Height < MINHEIGHT Then UserControl.Height = MINHEIGHT
        
    If CheckBox.Visible Then
            
        With txtPhoneNumber
            .Visible = False
            .Appearance = vbAppearanceFlat
            .BorderStyle = vbNone
            .Move 290, 40, ScaleWidth - 290 - 40, ScaleHeight - 80
            .Visible = True
        End With
        
        chkPhoneNumber.Move 80, (ScaleHeight / 2) - (chkPhoneNumber.Height / 2)
        
        With lblBackGround
            .Visible = False
            .Move 0, 0, ScaleWidth, ScaleHeight
            .Appearance = Appearance
            .BorderStyle = BorderStyle
            .Visible = True
        End With
        
        ' This seams to be a bug here... if you change a label's Appearance
        ' it'll 'forget' it's back color, so you must reset it each time
        ' after you toggle the property value
        
        BackColor = BackColor
        
    Else
        
        lblBackGround.Visible = False
        
        With txtPhoneNumber
            .Visible = False
            .BorderStyle = BorderStyle
            .Appearance = Appearance
            .Move 0, 0, ScaleWidth, ScaleHeight
            .Visible = True
        End With
        
    End If
        
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert False ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume Next
End Sub

Private Sub UserControl_Show()

    On Error Resume Next
    Debug.Print Now & " " & "Show"
    ResizeControl

End Sub

Private Sub UserControl_Terminate()
    
    Const PROC_SIG As String = MODULE & "." & "UserControl_Terminate[Sub]"
    
    On Error GoTo ErrorHandler
    
    Debug.Print "Terminate"
    
    Set m_objPhoneNumber = Nothing
    Set m_objFont = Nothing
    Set m_objCheckBox = Nothing
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert False ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume Next
End Sub

Public Property Let Alignment _
                        ( _
                        ByVal RHS As VBRUN.AlignmentConstants _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "Alignment[Let]"
    
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.Alignment = RHS
    PropertyChanged "Alignment"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get Alignment() As VBRUN.AlignmentConstants
Attribute Alignment.VB_Description = "Returns/sets the alignment of a CheckBox or OptionButton, or a control's text."
Attribute Alignment.VB_ProcData.VB_Invoke_Property = ";Misc"
    
    Alignment = txtPhoneNumber.Alignment

End Property

Public Property Let Appearance _
                        ( _
                        ByVal RHS As ApperaranceConstants _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "Appearence[Let]"
    
    On Error GoTo ErrorHandler
    
    m_enmAppearance = RHS
        
    If CheckBox.Visible Then
        lblBackGround.Appearance = RHS
    Else
        txtPhoneNumber.Appearance = RHS
    End If
        
    ' This seams to be a bug here... if you change a label's Appearance
    ' it'll 'forget' it's back color, so you must reset it each time
    ' after you toggle the property value
    
    BackColor = BackColor
    
    PropertyChanged "Appearance"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get Appearance() As ApperaranceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
    
    Appearance = m_enmAppearance

End Property

Public Property Let BackColor _
                        ( _
                        ByVal RHS As OLE_COLOR _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "BackColor[Let]"
    
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.BackColor = RHS
    lblBackGround.BackColor = RHS
    PropertyChanged "BackColor"
    
ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
    
    BackColor = txtPhoneNumber.BackColor

End Property

Public Property Let BorderStyle _
                        ( _
                        ByVal RHS As TextBoxBorderStyleConstants _
                        )
    
    Const PROC_SIG As String = MODULE & "." & "BorderStyle[Let]"
    
    On Error GoTo ErrorHandler
    
    m_enmBorderStyle = RHS
    If CheckBox.Visible Then
        lblBackGround.BorderStyle = RHS
    Else
        txtPhoneNumber.BorderStyle = RHS
    End If
    PropertyChanged "BorderStyle"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get BorderStyle() As TextBoxBorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    
    BorderStyle = m_enmBorderStyle

End Property

Private Sub txtPhoneNumber_Click()
    
    Debug.Print Now & " " & "txtPhoneNumber_Click"
    RaiseEvent Click
    
End Sub

Public Property Let Enabled _
                        ( _
                        ByVal RHS As Boolean _
                        )
        
    Const PROC_SIG As String = MODULE & "." & "Enabled[Let]"
        
    On Error GoTo ErrorHandler
    
    UserControl.Enabled = RHS
    PropertyChanged "Enabled"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
    
    Enabled = UserControl.Enabled

End Property

Public Property Set Font _
                        ( _
                        ByVal RHS As stdole.StdFont _
                        )
   
    Const PROC_SIG As String = MODULE & "." & "Font[Set]"
   
    On Error GoTo ErrorHandler
    
    With m_objFont
        .Bold = RHS.Bold
        .Italic = RHS.Italic
        .Name = RHS.Name
        .Size = RHS.Size
        .Underline = RHS.Underline
        .Strikethrough = RHS.Strikethrough
    End With
    PropertyChanged "Font"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get Font() As stdole.StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
Attribute Font.VB_UserMemId = -512

    Set Font = UserControl.Font

End Property

Public Property Let FontBold _
                        ( _
                        ByVal RHS As Boolean _
                        )
    Const PROC_SIG As String = MODULE & "." & "FontBold[Let]"

    On Error GoTo ErrorHandler
    
    Me.Font.Bold = RHS
    PropertyChanged "FontBold"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get FontBold() As Boolean

    FontBold = Me.Font.Bold

End Property

Public Property Let FontItalic _
                        ( _
                        ByVal RHS As Boolean _
                        )

    Const PROC_SIG As String = MODULE & "." & "FontItalic[Let]"

    On Error GoTo ErrorHandler
    
    Me.Font.Italic = RHS
    PropertyChanged "FontItalic"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get FontItalic() As Boolean

    FontItalic = Me.Font.Italic

End Property

Public Property Let FontName _
                        ( _
                        ByVal RHS As String _
                        )

    Const PROC_SIG As String = MODULE & "." & "FontName[Let]"

    On Error GoTo ErrorHandler
    
    Me.Font.Name = RHS
    PropertyChanged "FontName"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get FontName() As String

    FontName = Me.Font.Name

End Property

Public Property Let FontSize _
                        ( _
                        ByVal RHS As Single _
                        )

    Const PROC_SIG As String = MODULE & "." & "FontSize[Let]"

    On Error GoTo ErrorHandler
    
    Me.Font.Size = RHS
    PropertyChanged "FontSize"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get FontSize() As Single

    FontSize = Me.Font.Size

End Property

Public Property Let FontStrikethrough _
                        ( _
                        ByVal RHS As Boolean _
                        )

    Const PROC_SIG As String = MODULE & "." & "FontStriketrhrough[Let]"

    On Error GoTo ErrorHandler
    
    Me.Font.Strikethrough = RHS
    PropertyChanged "FontStrikethrough"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get FontStrikethrough() As Boolean

    FontStrikethrough = Me.Font.Strikethrough

End Property

Public Property Let FontUnderline(ByVal RHS As Boolean)
    
    Const PROC_SIG As String = MODULE & "." & "FontUnderline[Let]"
    
    On Error GoTo ErrorHandler
    
    Me.Font.Underline = RHS
    PropertyChanged "FontUnderline"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get FontUnderline() As Boolean

    FontUnderline = Me.Font.Underline

End Property

Public Property Let ForeColor(ByVal RHS As OLE_COLOR)
        
    Const PROC_SIG As String = MODULE & "." & "ForeColor[Let]"
        
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.ForeColor = RHS
    PropertyChanged "ForeColor"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
    
    ForeColor = txtPhoneNumber.ForeColor

End Property

Private Sub txtPhoneNumber_KeyDown(KeyCode As Integer, Shift As Integer)
        
    Const PROC_SIG As String = MODULE & "." & "txtPhoneNumber_KeyDown[Sub]"
        
    On Error GoTo ErrorHandler
        
    Debug.Print Now & " " & "txtPhoneNumber_KeyDown"
    If KeyCode = vbKeyF2 Then
        With txtPhoneNumber
            .SelLength = 0
            .SelStart = Len(.Text)
        End With
    End If
    
    RaiseEvent KeyDown(KeyCode, Shift)

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Sub

Private Sub txtPhoneNumber_KeyPress(KeyAscii As Integer)
    
    Debug.Print Now & " " & "txtPhoneNumber_KeyPress"
    RaiseEvent KeyPress(KeyAscii)

End Sub

Private Sub txtPhoneNumber_KeyUp(KeyCode As Integer, Shift As Integer)
    
    Debug.Print Now & " " & "txtPhoneNumber_KeyUp"
    RaiseEvent KeyUp(KeyCode, Shift)

End Sub

Public Property Let Locked(ByVal RHS As Boolean)
    
    Const PROC_SIG As String = MODULE & "." & "Locked[Let]"
    
    On Error GoTo ErrorHandler
        
    txtPhoneNumber.Locked = RHS
    PropertyChanged "Locked"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get Locked() As Boolean
Attribute Locked.VB_Description = "Determines whether a control can be edited."
Attribute Locked.VB_ProcData.VB_Invoke_Property = ";Behavior"
    
    Locked = txtPhoneNumber.Locked

End Property

Private Sub txtPhoneNumber_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Debug.Print Now & " " & "txtPhoneNumber_MouseDown"
    m_blnMouseEnter = True
    RaiseEvent MouseDown(Button, Shift, X, Y)

End Sub

Public Property Set MouseIcon(ByVal RHS As Picture)
    
    Const PROC_SIG As String = MODULE & "." & "MouseIcon[Set]"
    
    On Error GoTo ErrorHandler
        
    Set txtPhoneNumber.MouseIcon = RHS
    Set lblBackGround.MouseIcon = RHS
    Set chkPhoneNumber.MouseIcon = RHS
    
    PropertyChanged "MouseIcon"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
    
    Set MouseIcon = txtPhoneNumber.MouseIcon

End Property

Private Sub txtPhoneNumber_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Debug.Print Now & " " & "txtPhoneNumber_MouseMove"
    RaiseEvent MouseMove(Button, Shift, X, Y)

End Sub

Public Property Let MousePointer(ByVal RHS As VBRUN.MousePointerConstants)
    
    Const PROC_SIG As String = MODULE & "." & "MousePointer[Let]"
    
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.MousePointer = RHS
    lblBackGround.MousePointer = RHS
    chkPhoneNumber.MousePointer = RHS
    
    PropertyChanged "MousePointer"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get MousePointer() As VBRUN.MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
    
    MousePointer = txtPhoneNumber.MousePointer

End Property

Private Sub txtPhoneNumber_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    Debug.Print Now & " " & "txtPhoneNumber_MouseUp"
    m_blnMouseEnter = False
    RaiseEvent MouseUp(Button, Shift, X, Y)

End Sub

Public Property Let SelLength(ByVal RHS As Long)
    
    Const PROC_SIG As String = MODULE & "." & "SelLength[Let]"
    
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.SelLength = RHS
    PropertyChanged "SelLength"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get SelLength() As Long
Attribute SelLength.VB_Description = "Returns/sets the number of characters selected."
    
    SelLength = txtPhoneNumber.SelLength

End Property

Public Property Let SelStart(ByVal RHS As Long)
Attribute SelStart.VB_Description = "Returns/sets the starting point of text selected."
    
    Const PROC_SIG As String = MODULE & "." & "SelStart[Let]"
    
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.SelStart = RHS
    PropertyChanged "SelStart"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get SelStart() As Long
    
    SelStart = txtPhoneNumber.SelStart

End Property

Public Property Let SelText(ByVal RHS As String)
    
    Const PROC_SIG As String = MODULE & "." & "SelText[Let]"
    
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.SelText = RHS
    PropertyChanged "SelText"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get SelText() As String
Attribute SelText.VB_Description = "Returns/sets the string containing the currently selected text."
    
    SelText = txtPhoneNumber.SelText

End Property

Public Property Let Text(ByVal RHS As String)
    
    Const PROC_SIG As String = MODULE & "." & "Text[Let]"
    
    On Error GoTo ErrorHandler
    
    txtPhoneNumber.Text = RHS
    PropertyChanged "Text"

ExitHere:
    Exit Property
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
        .Raise .Number, AddErlToSource(PROC_SIG, Erl), .Description, .HelpFile, .HelpContext
    End With
End Property

Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
Attribute Text.VB_UserMemId = 0
    
    Text = txtPhoneNumber.Text

End Property

Private Sub UserControl_InitProperties()
        
    Const PROC_SIG As String = MODULE & "." & "UserControl_InitProperties[Sub]"
        
    On Error GoTo ErrorHandler
    
    Debug.Print "InitProperties"
        
    AutoChekDialog = True
        
    With CheckBox
        .Value = vbChecked
        .Visible = False
        .Appearance = vbAppearance3D
    End With
    
    BorderStyle = vbFixedSingle
    Appearance = vbAppearance3D
        
    With Me.PhoneNumber
        .CountryCode = vbNullString
        .CityCode = vbNullString
        .LocalNumber = vbNullString
        .Description = vbNullString
    End With
        
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume ExitHere
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    Const PROC_SIG As String = MODULE & "." & "UserControl_ReadProperties[Sub]"
    
    On Error GoTo ErrorHandler
    
    Debug.Print "ReadProperties"
    
    With PropBag
        Me.CheckBox.Visible = .ReadProperty("CheckBoxVisible", False)
        Debug.Print "CheckBox.Visible=" & Me.CheckBox.Visible
        Me.CheckBox.Value = .ReadProperty("CheckBoxValue", vbChecked)
        Me.CheckBox.Appearance = .ReadProperty("CheckBoxAppearance", vbAppearance3D)
        
        Me.Alignment = .ReadProperty("Alignment", vbLeftJustify)
        Me.Appearance = .ReadProperty("Appearance", vbAppearance3D)
        Me.BackColor = .ReadProperty("BackColor", vbWindowBackground)
        Me.BorderStyle = .ReadProperty("BorderStyle", vbFixedSingle)
        Me.Enabled = .ReadProperty("Enabled", True)
        
        Me.FontBold = .ReadProperty("FontBold", Ambient.Font.Bold)
        Me.FontItalic = .ReadProperty("FontItalic", Ambient.Font.Italic)
        Me.FontName = .ReadProperty("FontName", Ambient.Font.Name)
        Me.FontSize = .ReadProperty("FontSize", Ambient.Font.Size)
        Me.FontStrikethrough = .ReadProperty("FontStrikethrough", Ambient.Font.Strikethrough)
        Me.FontUnderline = .ReadProperty("FontUnderline", Ambient.Font.Underline)
        
        Me.ForeColor = .ReadProperty("ForeColor", vbWindowText)
        Me.Locked = .ReadProperty("Locked", False)
        Set Me.MouseIcon = .ReadProperty("MouseIcon", Nothing)
        Me.MousePointer = .ReadProperty("MousePointer", vbDefault)
        Me.SelLength = .ReadProperty("SelLength", 0)
        Me.SelStart = .ReadProperty("SelStart", 0)
        Me.SelText = .ReadProperty("SelText", vbNullString)
        Me.Text = .ReadProperty("Text", vbNullString)
        
        Me.PhoneCountryCode = .ReadProperty("PhoneCountryCode", vbNullString)
        Me.PhoneCityCode = .ReadProperty("PhoneCityCode", vbNullString)
        Me.PhoneLocalNumber = .ReadProperty("PhoneLocalNumber", vbNullString)
        Me.PhoneDescription = .ReadProperty("PhoneDescription", vbNullString)
    End With
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume ExitHere
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    
    Const PROC_SIG As String = MODULE & "." & "UserControl_WriteProperties[Sub]"
    
    On Error GoTo ErrorHandler
    
    Debug.Print "WriteProperties"
    
    With PropBag
        .WriteProperty "CheckBoxVisible", Me.CheckBox.Visible, False
        .WriteProperty "CheckBoxValue", Me.CheckBox.Value, vbChecked
        .WriteProperty "CheckBoxAppearance", Me.CheckBox.Appearance, vbAppearance3D
        
        .WriteProperty "Alignment", Me.Alignment, vbLeftJustify
        .WriteProperty "Appearance", Me.Appearance, vbAppearance3D
        .WriteProperty "BackColor", Me.BackColor, vbWindowBackground
        .WriteProperty "BorderStyle", Me.BorderStyle, vbFixedSingle
        .WriteProperty "Enabled", Me.Enabled, True
        
        .WriteProperty "FontBold", Me.FontBold, Ambient.Font.Bold
        .WriteProperty "FontItalic", Me.FontItalic, Ambient.Font.Italic
        .WriteProperty "FontName", Me.FontName, Ambient.Font.Name
        .WriteProperty "FontSize", Me.FontSize, Ambient.Font.Size
        .WriteProperty "FontStrikethrough", Me.FontStrikethrough, Ambient.Font.Strikethrough
        .WriteProperty "FontUnderline", Me.FontUnderline, Ambient.Font.Underline
        
        .WriteProperty "ForeColor", Me.ForeColor, vbWindowText
        .WriteProperty "Locked", Me.Locked, False
        .WriteProperty "MouseIcon", Me.MouseIcon, Nothing
        .WriteProperty "MousePointer", Me.MousePointer, vbDefault
        .WriteProperty "SelLength", Me.SelLength, 0
        .WriteProperty "SelStart", Me.SelStart, 0
        .WriteProperty "SelText", Me.SelText, vbNullString
        .WriteProperty "Text", Text, vbNullString
        
        .WriteProperty "PhoneCountryCode", Me.PhoneCountryCode, vbNullString
        .WriteProperty "PhoneCityCode", Me.PhoneCityCode, vbNullString
        .WriteProperty "PhoneLocalNumber", Me.PhoneLocalNumber, vbNullString
        .WriteProperty "PhoneDescription", Me.PhoneDescription, vbNullString
        
    End With
    
ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume ExitHere
End Sub

Public Sub ShowAbout()
Attribute ShowAbout.VB_UserMemId = -552
Attribute ShowAbout.VB_MemberFlags = "40"
    
    Const PROC_SIG As String = MODULE & "." & "ShowAbout[Sub]"
    
    Dim v_objAbout As frmAbout
    
    On Error GoTo ErrorHandler
    
    Set v_objAbout = New frmAbout
    
    v_objAbout.Show vbModal
    
    Set v_objAbout = Nothing

ExitHere:
    Exit Sub
ErrorHandler:
    Debug.Assert 0 ' Soft stop
    With VBA.Err
        Debug.Print "Error (" & .Number & ") " & .Description & " in " & AddErlToSource(PROC_SIG, Erl)
    End With
    Resume ExitHere
End Sub

